<?php
//
//	file: db_130_update.php
//	author: abdev
//	begin: 09/01/2012
//	version: 0.0.1 - 09/01/2012
//	licence: http://opensource.org/licenses/gpl-license.php GNU Public License
//

// ignore
define('IN_PHPBB', true);
$phpEx = substr(strrchr(__FILE__, '.'), 1);
$phpbb_root_path = defined('PHPBB_ROOT_PATH') ? PHPBB_ROOT_PATH : './';
include $phpbb_root_path . 'common.' . $phpEx;

// session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/info_acp_apiv');

// auth check
if ( $user->data['user_type'] != USER_FOUNDER )
{
	trigger_error('NOT_AUTHORISED');
}

if ( empty($config['apiv_version']) || !isset($config['apiv_version']) )
{
	// include db_tools
	include $phpbb_root_path . 'includes/db/db_tools.' . $phpEx;

	// perform schema changes
	$db_tools = new phpbb_db_tools($db);

	// change the type of those columns
	$db_tools->sql_column_change(FORUMS_TABLE, 'forum_last_poster_avatar', array('MTEXT', ''));
	$db_tools->sql_column_change(TOPICS_TABLE, 'topic_first_poster_avatar', array('MTEXT', ''));
	$db_tools->sql_column_change(TOPICS_TABLE, 'topic_last_poster_avatar', array('MTEXT', ''));

	// record now each value in its own field
	$sql = 'SELECT forum_id, forum_last_poster_avatar, forum_last_poster_avatar_type, forum_last_poster_avatar_width, forum_last_poster_avatar_height
		FROM ' . FORUMS_TABLE . '
		WHERE forum_last_poster_avatar <> \'\'';
	$result = $db->sql_query($sql);

	while ( $row = $db->sql_fetchrow($result) )
	{
		$avatar_info = serialize(array(
			'avatar' => $row['forum_last_poster_avatar'],
			'type' => $row['forum_last_poster_avatar_type'],
			'width' => $row['forum_last_poster_avatar_width'],
			'height' => $row['forum_last_poster_avatar_height'],
		));

		$sql = 'UPDATE ' . FORUMS_TABLE . '
			SET forum_last_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE forum_id = ' . (int) $row['forum_id'];
		$db->sql_query($sql);
	}

	// once more
	$sql = 'SELECT topic_id, topic_first_poster_avatar, topic_first_poster_avatar_type, topic_first_poster_avatar_width, topic_first_poster_avatar_height
		FROM ' . TOPICS_TABLE . '
		WHERE topic_first_poster_avatar <> \'\'';
	$result = $db->sql_query($sql);

	while ( $row = $db->sql_fetchrow($result) )
	{
		$avatar_info = serialize(array(
			'avatar' => $row['topic_first_poster_avatar'],
			'type' => $row['topic_first_poster_avatar_type'],
			'width' => $row['topic_first_poster_avatar_width'],
			'height' => $row['topic_first_poster_avatar_height'],
		));

		$sql = 'UPDATE ' . TOPICS_TABLE . '
			SET topic_first_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE topic_id = ' . (int) $row['topic_id'];
		$db->sql_query($sql);
	}

	// and once again
	$sql = 'SELECT topic_id, topic_last_poster_avatar, topic_last_poster_avatar_type, topic_last_poster_avatar_width, topic_last_poster_avatar_height
		FROM ' . TOPICS_TABLE . '
		WHERE topic_first_poster_avatar <> \'\'';
	$result = $db->sql_query($sql);

	while ( $row = $db->sql_fetchrow($result) )
	{
		$avatar_info = serialize(array(
			'avatar' => $row['topic_last_poster_avatar'],
			'type' => $row['topic_last_poster_avatar_type'],
			'width' => $row['topic_last_poster_avatar_width'],
			'height' => $row['topic_last_poster_avatar_height'],
		));

		$sql = 'UPDATE ' . TOPICS_TABLE . '
			SET topic_last_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE topic_id = ' . (int) $row['topic_id'];
		$db->sql_query($sql);
	}

	// delete those ones
	$db_tools->sql_column_remove(FORUMS_TABLE, 'forum_last_poster_avatar_type');
	$db_tools->sql_column_remove(FORUMS_TABLE, 'forum_last_poster_avatar_width');
	$db_tools->sql_column_remove(FORUMS_TABLE, 'forum_last_poster_avatar_height');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_first_poster_avatar_type');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_first_poster_avatar_width');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_first_poster_avatar_height');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_last_poster_avatar_type');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_last_poster_avatar_width');
	$db_tools->sql_column_remove(TOPICS_TABLE, 'topic_last_poster_avatar_height');

	// remove that setting
	$sql = 'DELETE FROM ' . CONFIG_TABLE . ' WHERE config_name = \'enable_avatar_index\'';
	$db->sql_query($sql);

	// add new settings and set version
	set_config('avatar_max_dimensions', 40);
	set_config('avatar_forums_last_poster_show', true);
	set_config('avatar_topics_first_poster_show', true);
	set_config('avatar_topics_last_poster_show', true);
	set_config('apiv_version', '1.3.0');

	// purge cache
	$cache->purge();

	$message = 'APIV_130_UPDATED';
}
else
{
	$message = 'APIV_130_GREATER';
}

// confirm
trigger_error($message);
