<?php
//
//	file: db_update.php
//	author: abdev
//	begin: 08/27/2012
//	version: 0.0.2 - 09/01/2012
//	licence: http://opensource.org/licenses/gpl-license.php GNU Public License
//

// ignore
define('IN_PHPBB', true);
define('UMIL_AUTO', true);
$phpbb_root_path = defined('PHPBB_ROOT_PATH') ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include $phpbb_root_path . 'common.' . $phpEx;

// start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if ( !file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx) )
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// language file which will be included when installing
$language_file = 'mods/info_acp_apiv';

// name of the mod
$mod_name = 'APIV';

// name of the config variable
$version_config_name = 'apiv_version';

// logo image
$logo_img = 'images/apiv_logo_small.png';

// array of versions and actions within each
$versions = array(
	'1.3.0' => array(

		'config_add' => array(
			array('avatar_max_dimensions', 40),
			array('avatar_forums_last_poster_show', true),
			array('avatar_topics_first_poster_show', true),
			array('avatar_topics_last_poster_show', true),
		),

		'table_column_add' => array(
			array('phpbb_forums', 'forum_last_poster_avatar', array('MTEXT_UNI', '')),
			array('phpbb_topics', 'topic_first_poster_avatar', array('MTEXT_UNI', '')),
			array('phpbb_topics', 'topic_last_poster_avatar', array('MTEXT_UNI', '')),
		),

		'custom' => 'resync',

		'cache_purge' => array('', 'template'),
	),

);

// include the UMIL Auto file, it handles the rest
include $phpbb_root_path . 'umil/umil_auto.' . $phpEx;

// special functions
function resync()
{
	global $db;

	$sql = 'SELECT user_id, user_avatar, user_avatar_type, user_avatar_width, user_avatar_height
		FROM ' . USERS_TABLE . '
		WHERE user_avatar <> \'\'';
	$result = $db->sql_query($sql);
	while ( $row = $db->sql_fetchrow($result) )
	{
		$avatar_info = serialize(array(
			'avatar' => $row['user_avatar'],
			'type' => (int) $row['user_avatar_type'],
			'width' => (int) $row['user_avatar_width'],
			'height' => (int) $row['user_avatar_height'],
		));

		$sql = 'UPDATE ' . FORUMS_TABLE . '
			SET forum_last_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE forum_last_poster_id = ' . (int) $row['user_id'];
		$db->sql_query($sql);

		$sql = 'UPDATE ' . TOPICS_TABLE . '
			SET topic_first_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE topic_poster = ' . (int) $row['user_id'];
		$db->sql_query($sql);

		$sql = 'UPDATE ' . TOPICS_TABLE . '
			SET topic_last_poster_avatar = \'' . $db->sql_escape($avatar_info) . '\'
			WHERE topic_last_poster_id = ' . (int) $row['user_id'];
		$db->sql_query($sql);
	}
	$db->sql_freeresult($result);

	return 'APIV_AVATARS_SYNCHRONIZED';
}
